
****** PD_SCRL.prg
PROC PD_SCRL
PARAMETER fld, als, ord, fltr, trow, tcol, brow, bcol, fldtp
SET TALK OFF

*** PARAMETERS VALUE EXPLANATION
* FLD  = Display Fields Of Scroll
* ALS  = File Alias
* ORD  = Set Order To
* FLTR = Set Filter To Expression
*** Dimensions Of The Inside Of The Window
* TROW = Top Row
* TCOL = Top Column
* BROW = Bottom Row
* BCOL = Bottom Column
* FLDTP = Prefix Used For SEEK  -  Only Used If Multiple Field Index Is Used


* The file is selected using an alias
SELECT &als

* The order is selected by using and .MDX TAG or .NDX number
SET ORDER TO &ord

* Create filter if one is needed
SET FILTER TO &fltr
GOTO TOP

* Store positioning record for top of scroll in memvar frec
frec = RECNO()

* Exits PD_SCRL and returns to the calling program if no records match filter ;
  statement or if no records are currently in the file.
IF EOF()
*pause
SET FILTER TO
RETURN
ENDIF

* Store positioning record for bottom of scroll in memvar lrec
GOTO BOTTOM
lrec = RECNO()

GOTO frec
SET EXACT OFF
*SET ESCAPE OFF

* Setting of colors for the scroll is only done once
* Highlighting is done by using GETS instead of changing colors and using SAYS
SET COLOR TO W/B, +W/R, B


* calculate the number of lines for scroll display
wndht = (brow - trow) + 1
scrnrow = trow

* Save orginal screen before displaying scroll
CALL DISPLAY WITH '/s'

* Draw the box/window on the screen
@ trow - 1, tcol - 1 to brow + 1, bcol + 1 double


* Initial display of records for scroll - highlighting top record
DO Fuldsp WITH .T.

* Memvar used for building seek key - bld = null string
bld = ''

**** Case statement may be placed here for column headings
**** The following CASE routine has been inserted from SCROLL3.PRG
**code to be placed before the main DO WHILE of PD_SCRL
* CHR() value for double horizontal line
dh=CHR(205)

* CHR() value for vertical/horizontal connection
vhc=CHR(203)

* The memvars trow & tcol contain the top row & column coordinance of the box
DO CASE

        CASE ord = '1' .AND. upper(ALS) = 'CM'
        *When using cmaster.dbf and index #1, use the following column headings
        @ trow-1, tcol+1 SAY "CODE" + vhc + dh + "CODE DESCRIPT"

        CASE ord = '2' .AND. upper(ALS) = 'EM'

        * When Using Employee.dbf and index #2, Use the following column headings
        @ trow-1, tcol+2 SAY "LAST NAME"+dh+dh+dh+vhc+"FIRST NAME"+dh+vhc+dh+"EMPL.#"

ENDCASE


DO WHILE .T.
  
    xkey = 0
    DO WHILE xkey = 0
        xkey = INKEY()
    ENDDO

    * Variable skey is saved if an A-9 key has been pressed
    skey = UPPER(CHR(xkey))


    * If A-9 has been pressed, the key pressed is saved in the memvar bld
    * If a cursor key has been pressed the contents of bld is cleared
    IF (skey >= 'A' .AND. skey <= 'Z') .OR. (skey >= '0' .and. skey <= '9')
        bld = bld + skey
    ELSE
        bld = ''
    ENDIF


    DO CASE


        * Check to see if the ESC or RETURN key has been pressed
        CASE xkey = 27 .or. xkey = 13

        * If the ESC key has been pressed position record pointer at EOF()
        IF xkey = 27
            GO BOTTOM
            SKIP 1
        ENDIF

        * Restore orginal screen before returning to calling program
        SET FILTER TO
        CALL DISPLAY WITH '/r'
        RETURN


        * Check to see if an alpha or numeric key has been pressed "A - 9"
        CASE (skey >= 'A' .AND. skey <= 'Z') .OR. (skey >= '0' .AND. skey <= '9')

            * Store current record before searching
            orgrec = RECNO()

            * Build search string from filter prefix plus bld memvar
            skey = LTRIM("&fldtp"+bld)

            SEEK skey

            IF FOUND()

                * When found, redisplay scroll using new record position
                DO Fuldsp WITH .T.

            ELSE

                * When not found, subtract one character from bld memvar and do
                * not redisplay screen instead wait for next key to be pressed.
                bld = SUBS(bld,1,LEN(bld)-1)
                GOto orgrec
            ENDIF
            LOOP


            * Check to see is UP arrow has been pressed
        CASE xkey = 5

            * Check to see if current record # is not equal to frec
            IF RECNO() <> frec

            * A conditional SAY routine to unhighlight the current record
            * and highlight the previous record
                IF scrnrow > trow
                    @ scrnrow,tcol SAY &fld
                    scrnrow = scrnrow - 1
                    SKIP -1
                    q = &fld
                    @ scrnrow, tcol get q
                    clear gets
                ELSE
                    SKIP -1
                    DO Fuldsp WITH .T.
                ENDIF
            ENDIF
            LOOP


        * Check to see if DOWN arrow key has been pressed
        CASE xkey = 24

            * Check to see if current record # is not equal to lrec
            IF RECNO() <> lrec

                * A conditional SAY routine to unhighlight the current
		* record and highlight the following record
                IF scrnrow < brow
                    @ scrnrow,tcol SAY &fld
                    scrnrow = scrnrow + 1
                    SKIP 1
                    q = &fld
                    @ scrnrow, tcol get q
                    clear gets
                ELSE
                    SKIP 2 - wndht
                    DO Fuldsp WITH .F.
                ENDIF
            ENDIF
            LOOP


        * Check to see if the PgDn key has been pressed
        CASE xkey = 3

            * If Not End Of File - Redisplay Scroll One Scroll Length Down
            IF RECNO() <> lrec
                SKIP trow - scrnrow +(2 * wndht) - 1
                IF EOF()
                    SKIP - wndht
                    DO Fuldsp WITH .F.
                ELSE
                    SKIP 1 - wndht
                    DO Fuldsp WITH .T.
                ENDIF
            ENDIF
            LOOP


        * Check to see if the PgUp key has been pressed
        CASE xkey = 18

            * If Not Top Of File - Redisplay Scroll One Scroll Length Up
            IF RECNO() <> frec
                SKIP trow - scrnrow - wndht
                IF BOF()
                    GOTO frec
                ENDIF
                DO Fuldsp WITH .T.
            ENDIF
            LOOP
  
  
        * Check to see if the HOME key has been pressed
        CASE xkey = 26

            * Redisplay Scroll Staring At Top Of File
            IF RECNO() <> frec
                GOto frec
                DO Fuldsp WITH .T.
            ENDIF


        * Check to see if the END key has been pressed
        CASE xkey = 2

            * Redisplay Scroll From Bottom Of File
            IF RECNO() <> lrec
                GOto lrec
                SKIP 1 - wndht
                IF BOF()
                    GOTO frec
                ENDIF
                DO Fuldsp WITH .F.
            ENDIF


     ENDCASE
  
ENDDO

*********END OF PD_SCRL**********************************************



****** PROCEDURE FULDSP
*** Redisplay Of Box/Window Contents For PD_SCROLL

PROC Fuldsp
PARA Mustdo

@ trow, tcol clear to brow, bcol

trec = RECNO()
cnt = trow

* Redisplay box/window contetents
DO WHILE .NOT. EOF() .AND. cnt <= brow
    @ cnt,tcol SAY &fld
    SKIP 1
    cnt = cnt+1
ENDDO

* Select top record if parameter "mustdo"=.t. else select bottom record
IF mustdo
    GOTO trec
    scrnrow = trow
ELSE
    SKIP -1
    scrnrow = cnt - 1
ENDIF

* Highlight selected record
q = &fld
@ scrnrow, tcol get q
clear gets
RETURN

*********END OF FULDSP************************************************
